---------------------------------------------------------------------------------------------------
--
-- Title       : relogio
-- Design      : relogio
-- Author      : Ney Laert Vilar Calazans
-- Company     : PUCRS-FACIN
--
---------------------------------------------------------------------------------------------------
--
-- File        : relogio.vhd
-- Generated   : Wed Apr 19 05:47:26 2006
-- From        : interface description file
-- By          : Itf2Vhdl ver. 1.20
--
---------------------------------------------------------------------------------------------------
--
-- Description : Relgio simples, que assume um clock de entrada de 10MHz
--
---------------------------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;



entity relogio is
	 port(
		 clock : in STD_LOGIC;
		 reset : in STD_LOGIC;
		 segundos : out integer range 59 downto 0;
		 minutos : out integer range 59 downto 0
	     );
end relogio;

--}} End of automatically maintained section

architecture relogio of relogio is	
signal cont_ticks : integer range 9999999 downto 0;
signal cont_segundos, cont_minutos : integer range 59 downto 0;
signal passou_1_seg, passou_1_min : std_logic;

begin

cont_1seg:
	process (clock, reset)
	begin
		if reset='1' then 
			cont_ticks <= 0;
			passou_1_seg <= '0';
		elsif clock'event and clock='1' then
			if cont_ticks=9 then
				cont_ticks <= 0;
				passou_1_seg <='1';
			else
				cont_ticks <= cont_ticks + 1;
				passou_1_seg <= '0';
			end if;
		end if;
	end process;

cont_segs:
	process (clock, reset)
	begin
		if reset='1' then		
			cont_segundos <= 0;
			passou_1_min <= '0';
		elsif clock'event and clock='0' then
			if passou_1_seg='1' then
				if cont_segundos = 59 then
					cont_segundos <= 0;
					passou_1_min <='1';
				else
					cont_segundos <= cont_segundos + 1;
				end if;
			else
				passou_1_min <='0';
			end if;	
		end if;
	end process;

	segundos <= cont_segundos;

end relogio;
